package models

import (
	"encoding/xml"
)

type MxGraphModel struct {
	XMLName xml.Name `xml:"mxGraphModel"`

	Root struct {
		XMLName xml.Name 	`xml:"root"`
		MxCell  []MxCell 	`xml:"mxCell"`
		MxObject	*[]MxObject	`xml:"object"`
	}
}

type MxCell struct {
	XMLName xml.Name `xml:"mxCell"`
	ID      string   `xml:"id,attr"`
	Parent  *string  `xml:"parent,attr"`
	RID     *string  `xml:"rID,attr"`
	Source  *string  `xml:"source,attr"`
	Target  *string  `xml:"target,attr"`
	Rtype	*string  `xml:"rType,attr"`
}


type MxObject struct {
	XMLName xml.Name 	`xml:"object"`
	ID		string		`xml:"id,attr"`
	Settings []xml.Attr	`xml:",any,attr"`
	MxCell	MxCell		`xml:"mxCell"`	
}

type mxissue struct {
	msg string
}

func (m *mxissue) Error() string {
	return m.msg
}

func newMxIssue(message string) error {
	return &mxissue{message}
}

